org.objectweb.asm.util

## Class CheckClassAdapter

- java.lang.Object
- - org.objectweb.asm.ClassVisitor
  - - org.objectweb.asm.util.CheckClassAdapter

-     public class CheckClassAdapter
      extends ClassVisitor

  A `ClassVisitor` that checks that its methods are properly used. More precisely this class adapter checks each method call individually, based only on its arguments, but does not check the sequence of method calls. For example, the invalid sequence `visitField(ACC_PUBLIC, "i", "I", null)` `visitField(ACC_PUBLIC, "i", "D", null)` will not be detected by this class adapter.

  `CheckClassAdapter` can be also used to verify bytecode transformations in order to make sure transformed bytecode is sane. For example:

         InputStream is = ...; // get bytes for the source class
         ClassReader cr = new ClassReader(is);
         ClassWriter cw = new ClassWriter(cr, ClassWriter.COMPUTE_MAXS);
         ClassVisitor cv = new MyClassAdapter(new CheckClassAdapter(cw));
         cr.accept(cv, 0);

         StringWriter sw = new StringWriter();
         PrintWriter pw = new PrintWriter(sw);
         CheckClassAdapter.verify(new ClassReader(cw.toByteArray()), false, pw);
         assertTrue(sw.toString(), sw.toString().length()==0);

  Above code runs transformed bytecode trough the `CheckClassAdapter`. It won't be exactly the same verification as JVM does, but it run data flow analysis for the code of each method and checks that expectations are met for each method instruction.

  If method bytecode has errors, assertion text will show the erroneous instruction number and dump of the failed method with information about locals and stack slot for each instruction. For example (format is - insnNumber locals : stack):

       org.objectweb.asm.tree.analysis.AnalyzerException: Error at instruction 71: Expected I, but found .
         at org.objectweb.asm.tree.analysis.Analyzer.analyze(Analyzer.java:289)
         at org.objectweb.asm.util.CheckClassAdapter.verify(CheckClassAdapter.java:135)
       ...
       remove()V
       00000 LinkedBlockingQueue$Itr . . . . . . . .  :
         ICONST_0
       00001 LinkedBlockingQueue$Itr . . . . . . . .  : I
         ISTORE 2
       00001 LinkedBlockingQueue$Itr . I . . . . . .  :
       ...

       00071 LinkedBlockingQueue$Itr . I . . . . . .  :
         ILOAD 1
       00072 ?
         INVOKESPECIAL java/lang/Integer.<init> (I)V
       ...

  In the above output you can see that variable 1 loaded by `ILOAD 1` instruction at position `00071` is not initialized. You can also see that at the beginning of the method (code inserted by the transformation) variable 2 is initialized.

  Note that when used like that, `CheckClassAdapter.verify()` can trigger additional class loading, because it is using `SimpleVerifier`.

  Author:
    Eric Bruneton

- - ### Field Summary

    - ### Fields inherited from class org.objectweb.asm.ClassVisitor

      `api, cv`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `CheckClassAdapter(ClassVisitor cv)` Constructs a new `CheckClassAdapter`.
    `` | `CheckClassAdapter(ClassVisitor cv, boolean checkDataFlow)` Constructs a new `CheckClassAdapter`.
    `protected` | `CheckClassAdapter(int api, ClassVisitor cv, boolean checkDataFlow)` Constructs a new `CheckClassAdapter`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `checkClassSignature(String signature)` Checks a class signature.
    `static void` | `checkFieldSignature(String signature)` Checks a field signature.
    `static void` | `checkMethodSignature(String signature)` Checks a method signature.
    `static void` | `main(String[] args)` Checks a given class.
    `static void` | `verify(ClassReader cr, boolean dump, PrintWriter pw)` Checks a given class
    `static void` | `verify(ClassReader cr, ClassLoader loader, boolean dump, PrintWriter pw)` Checks a given class.
    `void` | `visit(int version, int access, String name, String signature, String superName, String[] interfaces)` Visits the header of the class.
    `AnnotationVisitor` | `visitAnnotation(String desc, boolean visible)` Visits an annotation of the class.
    `void` | `visitAttribute(Attribute attr)` Visits a non standard attribute of the class.
    `void` | `visitEnd()` Visits the end of the class.
    `FieldVisitor` | `visitField(int access, String name, String desc, String signature, Object value)` Visits a field of the class.
    `void` | `visitInnerClass(String name, String outerName, String innerName, int access)` Visits information about an inner class.
    `MethodVisitor` | `visitMethod(int access, String name, String desc, String signature, String[] exceptions)` Visits a method of the class.
    `void` | `visitOuterClass(String owner, String name, String desc)` Visits the enclosing class of the class.
    `void` | `visitSource(String file, String debug)` Visits the source of the class.
    `AnnotationVisitor` | `visitTypeAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)` Visits an annotation on a type in the class signature.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CheckClassAdapter

          public CheckClassAdapter(ClassVisitor cv)

      Constructs a new `CheckClassAdapter`. Subclasses must not use this constructor. Instead, they must use the `CheckClassAdapter(int, ClassVisitor, boolean)` version.
      Parameters:
        `cv` - the class visitor to which this adapter must delegate calls.

    - #### CheckClassAdapter

          public CheckClassAdapter(ClassVisitor cv,
                                   boolean checkDataFlow)

      Constructs a new `CheckClassAdapter`. Subclasses must not use this constructor. Instead, they must use the `CheckClassAdapter(int, ClassVisitor, boolean)` version.
      Parameters:
        `cv` - the class visitor to which this adapter must delegate calls.
        `checkDataFlow` - `true` to perform basic data flow checks, or `false` to not perform any data flow check (see `CheckMethodAdapter`). This option requires valid maxLocals and maxStack values.
      Throws:
        `IllegalStateException` - If a subclass calls this constructor.

    - #### CheckClassAdapter

          protected CheckClassAdapter(int api,
                                      ClassVisitor cv,
                                      boolean checkDataFlow)

      Constructs a new `CheckClassAdapter`.
      Parameters:
        `api` - the ASM API version implemented by this visitor. Must be one of `Opcodes.ASM4` or `Opcodes.ASM5`.
        `cv` - the class visitor to which this adapter must delegate calls.
        `checkDataFlow` - `true` to perform basic data flow checks, or `false` to not perform any data flow check (see `CheckMethodAdapter`). This option requires valid maxLocals and maxStack values.

  - ### Method Detail

    - #### main

          public static void main(String[] args)
                           throws Exception

      Checks a given class.

      Usage: CheckClassAdapter <binary class name or class file name>

      Parameters:
        `args` - the command line arguments.
      Throws:
        `Exception` - if the class cannot be found, or if an IO exception occurs.

    - #### verify

          public static void verify(ClassReader cr,
                                    ClassLoader loader,
                                    boolean dump,
                                    PrintWriter pw)

      Checks a given class.
      Parameters:
        `cr` - a `ClassReader` that contains bytecode for the analysis.
        `loader` - a `ClassLoader` which will be used to load referenced classes. This is useful if you are verifiying multiple interdependent classes.
        `dump` - true if bytecode should be printed out not only when errors are found.
        `pw` - write where results going to be printed

    - #### verify

          public static void verify(ClassReader cr,
                                    boolean dump,
                                    PrintWriter pw)

      Checks a given class
      Parameters:
        `cr` - a `ClassReader` that contains bytecode for the analysis.
        `dump` - true if bytecode should be printed out not only when errors are found.
        `pw` - write where results going to be printed

    - #### visit

          public void visit(int version,
                            int access,
                            String name,
                            String signature,
                            String superName,
                            String[] interfaces)

      Description copied from class: `ClassVisitor`
      Visits the header of the class.
      Overrides:
        `visit` in class `ClassVisitor`
      Parameters:
        `version` - the class version.
        `access` - the class's access flags (see `Opcodes`). This parameter also indicates if the class is deprecated.
        `name` - the internal name of the class (see `getInternalName`).
        `signature` - the signature of this class. May be `null` if the class is not a generic one, and does not extend or implement generic classes or interfaces.
        `superName` - the internal of name of the super class (see `getInternalName`). For interfaces, the super class is `Object`. May be `null`, but only for the `Object` class.
        `interfaces` - the internal names of the class's interfaces (see `getInternalName`). May be `null`.

    - #### visitSource

          public void visitSource(String file,
                                  String debug)

      Description copied from class: `ClassVisitor`
      Visits the source of the class.
      Overrides:
        `visitSource` in class `ClassVisitor`
      Parameters:
        `file` - the name of the source file from which the class was compiled. May be `null`.
        `debug` - additional debug information to compute the correspondance between source and compiled elements of the class. May be `null`.

    - #### visitOuterClass

          public void visitOuterClass(String owner,
                                      String name,
                                      String desc)

      Description copied from class: `ClassVisitor`
      Visits the enclosing class of the class. This method must be called only if the class has an enclosing class.
      Overrides:
        `visitOuterClass` in class `ClassVisitor`
      Parameters:
        `owner` - internal name of the enclosing class of the class.
        `name` - the name of the method that contains the class, or `null` if the class is not enclosed in a method of its enclosing class.
        `desc` - the descriptor of the method that contains the class, or `null` if the class is not enclosed in a method of its enclosing class.

    - #### visitInnerClass

          public void visitInnerClass(String name,
                                      String outerName,
                                      String innerName,
                                      int access)

      Description copied from class: `ClassVisitor`
      Visits information about an inner class. This inner class is not necessarily a member of the class being visited.
      Overrides:
        `visitInnerClass` in class `ClassVisitor`
      Parameters:
        `name` - the internal name of an inner class (see `getInternalName`).
        `outerName` - the internal name of the class to which the inner class belongs (see `getInternalName`). May be `null` for not member classes.
        `innerName` - the (simple) name of the inner class inside its enclosing class. May be `null` for anonymous inner classes.
        `access` - the access flags of the inner class as originally declared in the enclosing class.

    - #### visitField

          public FieldVisitor visitField(int access,
                                         String name,
                                         String desc,
                                         String signature,
                                         Object value)

      Description copied from class: `ClassVisitor`
      Visits a field of the class.
      Overrides:
        `visitField` in class `ClassVisitor`
      Parameters:
        `access` - the field's access flags (see `Opcodes`). This parameter also indicates if the field is synthetic and/or deprecated.
        `name` - the field's name.
        `desc` - the field's descriptor (see `Type`).
        `signature` - the field's signature. May be `null` if the field's type does not use generic types.
        `value` - the field's initial value. This parameter, which may be `null` if the field does not have an initial value, must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String` (for `int`, `float`, `long` or `String` fields respectively). This parameter is only used for static fields. Its value is ignored for non static fields, which must be initialized through bytecode instructions in constructors or methods.
      Returns:
        a visitor to visit field annotations and attributes, or `null` if this class visitor is not interested in visiting these annotations and attributes.

    - #### visitMethod

          public MethodVisitor visitMethod(int access,
                                           String name,
                                           String desc,
                                           String signature,
                                           String[] exceptions)

      Description copied from class: `ClassVisitor`
      Visits a method of the class. This method must return a new `MethodVisitor` instance (or `null`) each time it is called, i.e., it should not return a previously returned visitor.
      Overrides:
        `visitMethod` in class `ClassVisitor`
      Parameters:
        `access` - the method's access flags (see `Opcodes`). This parameter also indicates if the method is synthetic and/or deprecated.
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `signature` - the method's signature. May be `null` if the method parameters, return type and exceptions do not use generic types.
        `exceptions` - the internal names of the method's exception classes (see `getInternalName`). May be `null`.
      Returns:
        an object to visit the byte code of the method, or `null` if this class visitor is not interested in visiting the code of this method.

    - #### visitAnnotation

          public AnnotationVisitor visitAnnotation(String desc,
                                                   boolean visible)

      Description copied from class: `ClassVisitor`
      Visits an annotation of the class.
      Overrides:
        `visitAnnotation` in class `ClassVisitor`
      Parameters:
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitTypeAnnotation

          public AnnotationVisitor visitTypeAnnotation(int typeRef,
                                                       TypePath typePath,
                                                       String desc,
                                                       boolean visible)

      Description copied from class: `ClassVisitor`
      Visits an annotation on a type in the class signature.
      Overrides:
        `visitTypeAnnotation` in class `ClassVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `CLASS_TYPE_PARAMETER`, `CLASS_TYPE_PARAMETER_BOUND` or `CLASS_EXTENDS`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitAttribute

          public void visitAttribute(Attribute attr)

      Description copied from class: `ClassVisitor`
      Visits a non standard attribute of the class.
      Overrides:
        `visitAttribute` in class `ClassVisitor`
      Parameters:
        `attr` - an attribute.

    - #### visitEnd

          public void visitEnd()

      Description copied from class: `ClassVisitor`
      Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.
      Overrides:
        `visitEnd` in class `ClassVisitor`

    - #### checkClassSignature

          public static void checkClassSignature(String signature)

      Checks a class signature.
      Parameters:
        `signature` - a string containing the signature that must be checked.

    - #### checkMethodSignature

          public static void checkMethodSignature(String signature)

      Checks a method signature.
      Parameters:
        `signature` - a string containing the signature that must be checked.

    - #### checkFieldSignature

          public static void checkFieldSignature(String signature)

      Checks a field signature.
      Parameters:
        `signature` - a string containing the signature that must be checked.